#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
sysread(STDIN,$data,$ENV{CONTENT_LENGTH});
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$data{$field}=$value;
	}
}

# Validation fields
$fullrn=$data{Wrname};
if (!$data{Name})
{
	push (@errors,"You must fill <b>Name</b> field<br>\n");
	$flag=1;
}
if (!$data{Wrname})
{
	push (@errors,"You must fill <b>WebRing name</b> field<br>\n");
	$flag=1;
}
if ($wurlrequired)
{
	if (($data{Wrurl} && $data{Wrurl}!~/^http:\/\//i) || $data{Wrurl}=~/^http:\/\/$/i || !$data{Wrurl})
	{
		push (@errors,"<b>URL</b> required and must start with http://<br>\n");
		$flag=1;
	}
}
else
{
	if (($data{Wrurl} && $data{Wrurl}!~/^http:\/\//i) || $data{Wrurl}=~/^http:\/\/$/i)
	{
		push (@errors,"<b>URL</b> must start with http:// or leave this field blank<br>\n");
		$flag=1;
	}
}
$data{Wrname}=~s/'/\\'/g;
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid FROM rw_rings WHERE rname='$data{Wrname}'");
$rid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($rid)
{
		push (@errors,"WebRing <b>$fullrn</b> is already exist in database. Choose other WebRing name.<br>\n");
		$flag=1;
}
if (!$data{Description})
{
	push (@errors,"<b>Description</b> is not defined<br>\n");
	$flag=1;
}
if (!$data{categ})
{
	push (@errors,"<b>Category</b> is not defined<br>\n");
	$flag=1;
}
if (!$data{Email})
{
	push (@errors,"You must fill <b>E-mail</b> field<br>\n");
	$flag=1;
}
unless ($data{Email}=~/.+\@.+/)
{
	push (@errors,"Field <b>E-mail</b> has incorrect value<br>\n");
	$flag=1;
}
if (!$data{Username})
{
	push (@errors,"You must fill <b>Choose username</b> field<br>\n");
	$flag=1;
}
if ($data{Username}=~/\W+/)
{
	push (@errors,"<b>Username</b> must consists of letters and digits<br>\n");
	$flag=1;
}
if (!$data{Password})
{
	push (@errors,"You must fill <b>Choose password</b> field<br>\n");
	$flag=1;
}
if ($data{Password}=~/\W+/)
{
	push (@errors,"<b>Password</b> must consists of letters and digits<br>\n");
	$flag=1;
}
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM rw_users WHERE username='$data{Username}'");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($uid)
{
	push (@errors,"User <b>$data{Username}</b> is already exist in database. Choose another username.<br>\n");
	$flag=1;
	last;
}
if ($flag)
{
	&error(@errors);
}

# Register User
$data{Description}=~s/\r\n/\<br\>/g;
$data{Description}=~s/'/\\'/g;
$data{Name}=~s/'/\\'/g;
$sth=$dbh->query("LOCK TABLES rw_users WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO rw_users (email,username,password,name,acctype,status) VALUES ('$data{Email}','$data{Username}','$data{Password}','$data{Name}',1,0)");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($uid)
{
	push (@errors,"Unknown SQL error. Cant register your account.<br>\n");
	&error(@errors);
}
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT hcode FROM rw_settings");
$htmlcode=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_rings WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO rw_rings (uid,rname,rurl,caid,rdescr,hcode) VALUES ($uid,'$data{Wrname}','$data{Wrurl}',$data{categ},'$data{Description}','$htmlcode')");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$rid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($rid)
{
	push (@errors,"Unknown SQL error. Cant register your webring.<br>\n");
	&error(@errors);
}

# Send email to admin
open (MAIL,"|$mailprog");
print MAIL "To: $rwemail\n";
print MAIL "From: $data{Email}\n";
print MAIL "Subject: New WebRing registered. Acception required.\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT ring_reg_to_admin,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);

# Print success
&closedb;
open(F,"<$rwpath/template/success.tpl");
@html=<F>;
close(F);
$successmsg="Your WebRing is registered succesfully and will be accepted by admin within 24 hours. We'll email you when your webring will be activated.";
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;

sub error
{
@errors=@_;
&closedb;
open(F,"<$rwpath/template/error.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
